
use pubs
go

-- select * from sys.service_contracts

create queue pubs_event_queue
go

create service pubs_event_service
  on queue pubs_event_queue
  ([http://schemas.microsoft.com/SQL/Notifications/PostEventNotification])
go

create event notification pubs_event_notif
  on database
  for create_table
  to service 'pubs_event_service', 'current database'
go

create table test (id int)
go
drop table test
go

select convert(xml, message_body) from pubs_event_queue
go

-- cleanup
drop event notification pubs_event_notif
  on database 
drop service pubs_event_service
drop queue pubs_event_queue
go