
use pubs
go

create procedure cleanup_all_endpoints
AS
BEGIN
DECLARE @h UNIQUEIDENTIFIER
DECLARE c CURSOR FOR
 SELECT conversation_handle FROM sys.conversation_endpoints
OPEN c
FETCH NEXT FROM c INTO @h
WHILE (@@FETCH_STATUS = 0)
BEGIN
  END CONVERSATION @h WITH CLEANUP
  FETCH NEXT FROM c INTO @h
END
CLOSE c
DEALLOCATE c
END
go

EXECUTE cleanup_all_endpoints
go

-- create initiator and target
-- 

create queue initq
create queue targq
go

create service initservice
  on queue initq
create service targservice
  on queue targq
  ([DEFAULT])
go

declare @h uniqueidentifier;
declare @i int;
set @i = 1;

while @i < 4
begin
  set @h = null;
  begin dialog conversation @h
    from service initservice
    to service 'targservice'
    with encryption = off;
  send on conversation @h ('Message ' + cast(@i as varchar(3)));
  set @i = @i + 1  
end
go

select * from sys.conversation_endpoints
go

-- three messages
select convert(xml, message_body) from targq;
go

-- one messages
receive convert(xml, message_body) from targq;
go

exec cleanup_all_endpoints
go

declare @h uniqueidentifier;
declare @h1 uniqueidentifier;
declare @i int;
set @i = 1;

begin dialog conversation @h
  from service initservice
  to service 'targservice'
  with encryption = off;
send on conversation @h ('Message ' + cast(@i as varchar(3)));
set @h1 = @h;
set @i = @i + 1;

while @i < 4
begin
  set @h = null;
  begin dialog conversation @h
    from service initservice
    to service 'targservice'
    with related_conversation = @h1, 
      encryption = off;
  send on conversation @h ('Message ' + cast(@i as varchar(3)));
  set @i = @i + 1  
end
go

select * from sys.conversation_endpoints;
select * from targq
go

-- three messages
select convert(xml, message_body) from targq;
go

-- one message, no conv group on target
receive convert(xml, message_body) from targq
go

declare @h uniqueidentifier
declare @msg varchar(100)
declare @i int
set @i = 1

while @i < 4
begin
  receive top(1) 
    @msg = convert(varchar(100), message_body),
    @h = conversation_handle
  from targq;
  send on conversation @h ('Response' + convert(varchar(5), @i))
  set @i = @i + 1
end  
go

select convert(xml, message_body) from initq;
go

select * from initq
go

-- three messages, receives all messages to this conv group
receive convert(xml, message_body) from initq
go

exec cleanup_all_endpoints
go