
alter database pubs set trustworthy on

use pubs
go
create master key encryption by password = 'StrongPW1'
go

use northwind
go
create master key encryption by password = 'StrongPW1'
go

use northwind
go

create queue northwind_event_queue
go

create service northwind_event_service
  on queue northwind_event_queue
  ([http://schemas.microsoft.com/SQL/Notifications/PostEventNotification])
go



use pubs
go

-- use the guid in 
declare @g uniqueidentifier
set @g = (select service_broker_guid from sys.databases
  where name = 'Northwind')

create event notification pubs_event_notif
  on database
  for create_table
  to service 'northwind_event_service', 'C87B1BAE-EE9E-409B-960F-017F8BE1B885'
go

create table test (id int)
go
drop table test
go

select convert(xml, message_body)
  from northwind.dbo.northwind_event_queue
go

-- cleanup
use pubs
go
drop event notification pubs_event_notif
  on database 

use northwind
go
drop service northwind_event_service
drop queue northwind_event_queue
go