
:CONNECT ZMV17
go

use master 
go

CREATE ENDPOINT BrokerEndpoint
    STATE = STARTED
    AS TCP ( LISTENER_PORT = 4037 )
    FOR SERVICE_BROKER ( AUTHENTICATION = WINDOWS ) ;
GO

:CONNECT ZMV17\SQL1
go

use master 
go

CREATE ENDPOINT BrokerEndpoint
    STATE = STARTED
    AS TCP ( LISTENER_PORT = 4038 )
    FOR SERVICE_BROKER ( AUTHENTICATION = WINDOWS ) ;
GO

:CONNECT ZMV17\SQL1

use pubs
go

create master key encryption by password = 'StrongPW1'
go

create queue sql1_pubs_event_queue
go

create service sql1_pubs_event_service
  on queue sql1_pubs_event_queue
  ([http://schemas.microsoft.com/SQL/Notifications/PostEventNotification])
go

grant send on service::sql1_pubs_event_service to public

select service_broker_guid
  from sys.databases 
  where name = 'pubs'
go

-- C8A77B8B-D37B-4B08-B023-9CA220020E53

:CONNECT ZMV17

use pubs
go

create event notification pubs_event_notif
  on database
  for create_table
  to service 'sql1_pubs_event_service', 'C8A77B8B-D37B-4B08-B023-9CA220020E53'
go

create route pubs_event_route
with service_name = 'sql1_pubs_event_service',
     broker_instance = 'C8A77B8B-D37B-4B08-B023-9CA220020E53',
     address = 'TCP://zmv17:4038'

create table test (id int)
go
drop table test
go

:CONNECT ZMV17\SQL1

use pubs
go

select convert(xml, message_body)
  from sql1_pubs_event_queue
go

-- cleanup

:CONNECT ZMV17\SQL1

use pubs
go


drop service sql1_pubs_event_service
drop queue sql1_pubs_event_queue
go

use master
drop endpoint BrokerEndpoint
go

:CONNECT ZMV17

use pubs
go

drop event notification pubs_event_notif
  on database
drop route pubs_event_route
go 

use master
drop endpoint BrokerEndpoint
go